static void osbvAllocateViewpointCompleted
(VP_AllocateViewpointTicket * avp_ticket)
{
    OPEN_SUBF_CONTEXT * c = (OPEN_SUBF_CONTEXT *) avp_ticket->p.t;
    LX_MAPI_OPEN_SOME_BIF_VIEWS * osbv_ticket = c->osbv_ticket;
    unsigned32 bifs_index = c->bifs_index;
    LX_ObjectId objID = c->objID;
    delete c;
    
    HRESULT avp_res = avp_ticket->status_o;

    VP_FolderTableViewpoint childView = avp_ticket->tViewpoint_o;
    
    delete avp_ticket;

    const bool is_pub = osbv_ticket->is_pub;
    const BIF_ATTRIBS * bifs = osbv_ticket->bifs;
    unsigned int * recurses = osbv_ticket->recurses;
    const VP_FolderTableViewpoint view = osbv_ticket->view;
    const MsgStore msg_store = view->getFE_MsgStore();
    const MsCharacteristics ms_chars = msg_store->ms_chars;

    if (avp_res != SUCCESS_SUCCESS)
    {
        DEBUGX(1, "FAILED!");
    }
    else
    {
        // open succeeded
        
        unsigned int offs_root;
        unsigned int offs_ipm_subtree;
        if (is_pub)
        {
            offs_root = BIFEID_OFFS_PUB_ROOT;
            offs_ipm_subtree = BIFEID_OFFS_PUB_IPM_SUBTREE;
        }
        else
        {
            offs_root = BIFEID_OFFS_USR_UKWN_ROOT;
            offs_ipm_subtree = BIFEID_OFFS_USR_IPM_SUBTREE;        
        }        

        /*
         * Obsolete ?
        if (bifs[bifs_index].bifeid_offs == offs_root)
            msg_store->root_viewpoint = childView;
        else if (bifs[bifs_index].bifeid_offs == offs_ipm_subtree) 
            msg_store->tois_viewpoint = childView;
        */

        add_oid_pair(objID, // this row
                     view->getObjectId() // parent
            );

        LX_MAPI_OPEN_SOME_BIF_VIEWS * osbv_child_ticket =
            new LX_MAPI_OPEN_SOME_BIF_VIEWS;
        osbv_child_ticket->view = childView;
        osbv_child_ticket->is_pub = is_pub;
        osbv_child_ticket->bifs = (BIF_ATTRIBS *) bifs;
        osbv_child_ticket->recurses = recurses;
        osbv_child_ticket->ticket_for_parent = osbv_ticket;
        osbv_child_ticket->completion = openSomeBIFViewsCompletion;

        osbv_ticket->subfldrs_to_do ++;
        // osbv_ticket->subfldrs_to_do gets decremented again in the
        // completion routine for the osbv_child_ticket we're about to
        // submit
                
        (*recurses)++; // gets dec'ed again in completion
        submitOpenSomeBIFViews(osbv_child_ticket);
    }
}


/*
 * OPEN_ALL_BIF_VIEWS opens views to all of the built-in folders so we know
 * where to find them when we go looking.
 */
struct LX_MAPI_OPEN_ALL_BIF_VIEWS;
typedef void (*LX_MAPI_OpenAllBIFViewsCompletion)
    (LX_MAPI_OPEN_ALL_BIF_VIEWS *);
struct LX_MAPI_OPEN_ALL_BIF_VIEWS : LX_Ticket
{
    LX_MAPI_OpenAllBIFViewsCompletion completion;
    HRESULT res;

    void * context; // for use of caller

    // internal to operation of OPEN_ALL_BIF_VIEWS:
    unsigned int recurses;

    // in parms:
    MsgStore msg_store; // for which all the views are opened

    LX_MAPI_OPEN_ALL_BIF_VIEWS() :
        recurses(0)
        {}
                
};
void openSomeBIFViewsBaseCompletion(LX_MAPI_OPEN_SOME_BIF_VIEWS * osbv_ticket)
{
    LX_MAPI_OPEN_ALL_BIF_VIEWS * ticket = (LX_MAPI_OPEN_ALL_BIF_VIEWS *)
        (osbv_ticket->context);
    const HRESULT osbv_res = osbv_ticket->res;
    const VP_FolderTableViewpoint view = osbv_ticket->view;
    LX_MAPISession * session = view->getMapiSession();
    if (osbv_res == SUCCESS_SUCCESS)
        ;// session->addBuiltInView(view);
    else
        ticket->res = osbv_res;
    delete osbv_ticket;
    
    ticket->completion(ticket);
}
void submitOpenAllBIFViews(LX_MAPI_OPEN_ALL_BIF_VIEWS * ticket)
{
    MsgStore msg_store = ticket->msg_store;
    bool is_pub = msg_store->ms_chars->is_pub;
    
    BIF_ATTRIBS * bif_attr = (BIF_ATTRIBS *)
      ((is_pub) ? (&(pub_bif_attrib_tab[0])) : (&(bif_attrib_tab[0])));

    LX_MAPI_OPEN_SOME_BIF_VIEWS * osbv_ticket =
                    new LX_MAPI_OPEN_SOME_BIF_VIEWS;
    osbv_ticket->view = msg_store->base_viewpoint;
    osbv_ticket->is_pub = is_pub;
    osbv_ticket->bifs = bif_attr;
    osbv_ticket->recurses = &(ticket->recurses);
    osbv_ticket->context = ticket;
    osbv_ticket->completion = openSomeBIFViewsBaseCompletion;
    submitOpenSomeBIFViews(osbv_ticket);
}


/*
 * We'll just comment all this out for now...
 * 
// --------------------------------------------------------------------------
// cleanRemDelete - helper routine for CleanUpRemindersFolder
// --------------------------------------------------------------------------
static void cleanRemDelete( VP_ObjectViewpoint remView, const LX_ObjectId& ghostOID)
{
    if( ghostOID.isNull())
    {
        DEBUGX(0, "CleanRem: cleanRemDelete called with NULL ghost oid");
    }
    else
    {
        char goidstr[32];
        ghostOID.sprint( goidstr);
        DEBUGX(1, "CleanRem: DELETING ghost %s", goidstr);
        HRESULT res = remView->fldview()->deleteChildObject( ghostOID);
        if( res != SUCCESS_SUCCESS)
        {
            DEBUGX(0,"CleanRem: Error code from deleteChildObject()=%lx", res);
        }
    }
} // end of cleanRemDelete

// --------------------------------------------------------------------------
// CleanUpReminderFolder - Remove invalid Reminder Objects
// --------------------------------------------------------------------------
//
// There may be objects in the Reminders folder that are not proper ghost
// objects. This could be caused by a system crash and partially completed
// store updates. The initial use of this routine is to cleanup bad ghost
// objects created by early versions of the LXD code.
//
// A proper Ghost Object must:
//   A) point to a True Object (prop D112)
//   B) have the ancestry list of the True Object (prop D113)
//   C) be able to open the True object
//   D) the True object must refer to the ghost (prop D114)
//   E) the True object should have a valid ancestry list for the Ghost
// If any of these conditions are not met the Ghost object is removed
// from the Reminders folder.
//
// --------------------------------------------------------------------------
HRESULT CleanUpReminderFolder( LX_MAPISession *session, const MsgStore msg_store)
{
    char toidstr[32], goidstr[32], tgoidstr[32];

//    unsigned int ms = session->msg_store_arr_size();
//    if( ms > 1)
//        return SUCCESS_SUCCESS;    // only cleanup folder once per user logon
    
    // Open a view of the Reminders folder
    //
    VP_ObjectViewpoint remindersView;
    remindersView = LXVMGR()->openBuiltInFolder( session, msg_store,
                                       BISFEID_OFFS_USR_36D5_REMINDERS,
                                                 OPEN_VIEW_NO_HANDLE);
    if( !remindersView)
    {
        DEBUGX(0, "CleanRem: ERROR Could NOT open builtin Reminders folder");
        LX_CHECK(0);
        return CdoE_NOT_ENOUGH_RESOURCES;
    }
    remindersView->addExtendedTag(PR_ENTRYID);
    remindersView->addExtendedTag(PR_OBJECT_TYPE);
    // get properties for "ghost" info
    remindersView->addExtendedTag(PR_D112_REF_OID);
    remindersView->addExtendedTag(PR_D113_REF_ANCESTRY_OID);
    remindersView->fldview()->setQueryFlags( QUERY_ALL_ROWS_ALL);

    // updateRows, but no OID pairs & no ghost translation
    remindersView->fldview()->updateRowsSpecial( false, false);
    DR_RowSetHandle  rows = remindersView->fldview()->getRows();
    
    unsigned32 num_Srows = rows->numRows();
    LXTRACE(LXTT_MAPI, "CleanRem: Found %lu rows in Reminders folder", num_Srows);

    // look for invalid reminder objects
    for ( unsigned32 jk = 0; jk < num_Srows; jk++ )
    {
        const LX_Property *pvr;
        LX_ObjectId ghostOID;

        // Get Oid of this row object, ie. the ghost obj
        if( (pvr=rows[jk].find(PR_ENTRYID)) == NULL)
        { // Error every object has an entry id
            DEBUGX(0, "ERROR row %lu object has no PR_ENTRYID", jk);
            LX_CHECK(0);
            continue;
        }
        ghostOID.setNull();
        get_objid_from_entryid( ghostOID, pvr->val.bin, msg_store->db);
        ghostOID.sprint( goidstr);
        
        if ( (pvr=rows[jk].find(PR_D112_REF_OID)) != NULL )
        {   // the current row [jk] has a reference to a true obj

            LX_ObjectId trueObjID;
            ref_oid2xchg_oid( pvr, trueObjID); // oid from prop
            trueObjID.sprint( toidstr);    
            DEBUGX(1, "CleanRem: row=%lu. is Ghost Obj=%s ref's True Obj=%s",
                   jk, goidstr, toidstr);

            // get the true obj ancestor list from the ghost
            const LX_Property *pvTrue;
            pvTrue = rows[jk].find(PR_D113_REF_ANCESTRY_OID);
            if( !pvTrue)
            {
                DEBUGX(1, "CleanRem: Ghost Error, no Ancestry");
                cleanRemDelete( remindersView, ghostOID); 
                continue;    // go to next folder row
            }
            LX_SBinary *psb = 0;
            if (pvTrue->val_to_switch == PT_BINARY)
            {
                psb = pvTrue->val.bin;
            }
                
            if( !psb)
            {
                DEBUGX(1, "CleanRem: Ghost Error, no Ancestry prop value");
                cleanRemDelete( remindersView, ghostOID); 
                continue;    // go to next folder row
            }

            //note - If any of the Ancestry list can NOT be opened that
            // will cause all the ancestry children opens to fail.
            // This means the "true" object open will fail.
            // So errors are only check for the "true" object open.
                
            int acount = ancestry_getCount( psb);
            // get view handles for all ancestors
            VP_ObjectViewpoint *anlst = new VP_ObjectViewpoint[acount];
            {for(int jk=0;jk < acount; anlst[jk]=NULL,jk++);}  // set to NULLs
            // note: new VP_ObjectViewpoint's are NULL
            ancestry_openAllParents( anlst, psb, session, msg_store);
            // at this point all true ancestors should be open
            // anlst[0] is VP_ObjectViewpoint of true direct parent

            // use _D112_ ObjID to open the "true" object
            VP_ObjectViewpoint trueV = NULL;
            if( anlst[0])
                trueV = LXVMGR()->openView( session, msg_store,
                                        anlst[0],
                                        trueObjID,
                                        false);

            // done with true ancestor views, so release/delete/free
            for( int ii=0; ii < acount; ii++)
            {
                if( anlst[ii]) LXVMGR()->deleteView( anlst[ii]);
            }
            delete[] anlst;
 
            if( !trueV)
            { // trueV is NULL if an ancestor openView failed
                // this is a bad ghost
                DEBUGX(1, "CleanRem: could not open true obj");
                cleanRemDelete( remindersView, ghostOID); 
                continue;    // go to next folder row
            }
            else
            { // have the True object, check that it references 'this' ghost
                LX_ObjectId objID;
                // True D114 must contain this ghostOID

                trueV->addExtendedTag(PR_ENTRYID);
                trueV->addExtendedTag(PR_OBJECT_TYPE);
                trueV->addExtendedTag(PR_D114_GHOST_REF_OID);
                trueV->addExtendedTag(PR_D115_GHOST_ANCESTRY_REF_OID);
                trueV->update();      // load the true obj props

                pvr = trueV->findObjectProperty(PR_D114_GHOST_REF_OID);
                const LX_Property *pvr_d115;
                pvr_d115 = trueV->findObjectProperty(PR_D115_GHOST_ANCESTRY_REF_OID);
                LXVMGR()->deleteView( trueV);   // done with true obj view
                
                if( !pvr)
                {
                    DEBUGX(1, "CleanRem: Did NOT find D114 Ghost ref in True obj");
                    cleanRemDelete( remindersView, ghostOID); 
                    continue;    // go to next folder row
                }
                else
                {
                    ref_oid2xchg_oid( pvr, objID); // oid from prop
                    objID.sprint( tgoidstr);
                    if( objID.isNull())
                    { // have ghost prop, but it does not have a value
                        // this is bad ghost

                        DEBUGX(1, "CleanRem: D114 oid is NULL");
                        DEBUGX(1, "CleanRem: True does not ref to ghost DELETING ghost %s", goidstr);
                        cleanRemDelete( remindersView, ghostOID); 
                        continue;    // go to next folder row
                    }
                    else
                    { // check true is referencing this ghost
                        DEBUGX(1, "CleanRem: True (%s) D114 ref to %s",
                               toidstr, tgoidstr);
                        if( objID != ghostOID)
                        { // True obj does NOT reference this ghost
                            DEBUGX(1, "CleanRem: True does not ref to ghost DELETING ghost %s", goidstr);
                            cleanRemDelete( remindersView, ghostOID); 
                            continue;    // go to next folder row
                        }
                    }
                }
                if( !pvr_d115)
                { // no ancestry -- bad 
                    DEBUGX(1, "CleanRem: Did NOT find D115 Ghost ancestry");
                    cleanRemDelete( remindersView, ghostOID);
                    continue;    // go to next folder row
                }
                else
                { // check that ancestry matches (optional)
                    // since the oid matches, how could this be wrong?
                }
            } // end of if !trueV else...
        } // end of if ghost
        else
        { // object is not a ghost, it should not be in Reminders folder
            if( !ghostOID.isNull())
            {
                cleanRemDelete( remindersView, ghostOID); 
                continue;    // go to next folder row
            }
        }
    } // for all rows
    LXVMGR()->deleteView(remindersView); 
    return SUCCESS_SUCCESS;
} // end of CleanUpReminderFolder

/////////////////////////////////////////////////////////////////////////////
// This is the place to cleanup any problems in a builtin folder
//
HRESULT CleanUpAllBuiltinFolders(LX_MAPISession * session,
                                  const MsgStore msg_store,
                                  bool is_pub)
{
    // as of 6-Aug-04 the only known problems to clean up are in the
    // Reminders folder. Old code had created reminder objects that
    // are not usable, but there is no way to delete them from OUTLOOK
    if( !is_pub)
    { // process non-public builtin folders

        // Reminder Folder - look for invalid reminder objects
        CleanUpReminderFolder( session, msg_store);
        
    } // end of non-public builtin folders
    
    return SUCCESS_SUCCESS;
} // end of CleanUpAllBuiltinFolders

 *
 * End of commented-out clean-up folders stuff
 */


/////////////////////////////////////////////////////////////////////////////
/*
 * setup_store_table_msg_store is called to read in data entries
 * when an existing store is opened; it allocates and fills the
 * MSG_STORE structure for this session.
 *
 * Note that the store MUST exist before this functions is called - in
 * other words, we must have successfully called get_store on the
 * store first.
 */

 void MsCharacteristicsI::
 submitInitExistingMsgStore(LX_MAPI_INIT_EXISTING_MSG_STORE * ticket)
{
    const MsgStore msg_store = ticket->msg_store;
    LX_MAPISession * session = msg_store->session;
    MsCharacteristics ms_chars;
    
    const HRESULT get_msc_res =
        session->getMsCharsByAccountA(&ms_chars, ticket->bh_account_a);

    if (get_msc_res == SUCCESS_SUCCESS)
    {
        // ms_chars already setup, so move straight to opening the base
        msg_store->ms_chars = ms_chars;
        iemsNewAndSubmitOpenBase(ticket);
        return;
    }

    // There's no ms_chars for this store, we need to create and setup one

    
    ms_chars = new MsCharacteristicsI(session,
                                      ticket->bh_account_a,
                                      ticket->is_pub);
    
    LX_MAPI_SETUP_MS_CHARS * setup_msc_ticket =
        new LX_MAPI_SETUP_MS_CHARS(iemsSetupMscCompletion,
                                   ticket,
                                   session,
                                   ms_chars,
                                   ticket->bh_account_a,
                                   ticket->is_pub);
    
    ms_chars->submitSetupMsChars(setup_msc_ticket);
}
void MsCharacteristicsI::iemsSetupMscCompletion
(LX_MAPI_SETUP_MS_CHARS * setup_msc_ticket)
{
    LX_MAPI_INIT_EXISTING_MSG_STORE * ticket =
        (LX_MAPI_INIT_EXISTING_MSG_STORE *)(setup_msc_ticket->context);
    const HRESULT setup_msc_res = setup_msc_ticket->res;
    const MsCharacteristics ms_chars = setup_msc_ticket->ms_chars;

    delete setup_msc_ticket;
    
    if (setup_msc_res)
    { 
        ticket->res = setup_msc_res;
        ticket->completion(ticket);
        return; // The ms_chars will be deleted here - no more refs
    }

    ticket->msg_store->ms_chars = ms_chars;
    iemsNewAndSubmitOpenBase(ticket);
}

    
void MsCharacteristicsI::iemsNewAndSubmitOpenBase
(LX_MAPI_INIT_EXISTING_MSG_STORE * ticket)
{
    LX_MAPI_OPEN_BASE * open_base_ticket = new LX_MAPI_OPEN_BASE;
    open_base_ticket->msg_store = ticket->msg_store;
    open_base_ticket->assignHandle = false;
    open_base_ticket->context = ticket;
    open_base_ticket->completion = iemsOpenBaseCompletion;
    submitOpenBase(open_base_ticket);
}

static void iemsUpdateRowsCompletion
(CRSR_GetNextRowTicket * update_row_ticket);

void MsCharacteristicsI::iemsOpenBaseCompletion
(LX_MAPI_OPEN_BASE * open_base_ticket)
{
    LX_MAPI_INIT_EXISTING_MSG_STORE * ticket =
        (LX_MAPI_INIT_EXISTING_MSG_STORE *)(open_base_ticket->context);
    HRESULT open_base_ticket_res = open_base_ticket->res;
    
    delete open_base_ticket;

    if (open_base_ticket_res)
    {
        ticket->res = open_base_ticket_res;
        ticket->completion(ticket);
        return;
    }
    
    const MsgStore msg_store = ticket->msg_store;
    LX_MAPISession * session = msg_store->session;
    LX_S bh_account_a = ticket->bh_account_a;
    const MsCharacteristics ms_chars = msg_store->ms_chars;

    static const unsigned32 non_bifeid_tags_to_get[] = {
        PR_ENTRYID,
        PR_IPM_SUBTREE_ENTRYID, // An MDB property
        PR_STORE_ENTRYID,       // also contains client x400 address,
        // account_address, store_entry_id_uid1,
        // store_entry_id_uid2,
        PR_STORE_RECORD_KEY,
        PR_3FE1_AF_CODE_PAGE,   // exists in root folder
        PR_3FFE_AF,             // exists in root folder
        PR_0E59_AF,             // subseq2 is the start of this property for
                                // root
        PR_DISPLAY_NAME_A,
	PR_OBJECT_TYPE,
    };

    // Take a copy of the account address
    // !!!! For future reference, do we need to take this address from
    // the X.400 address instead of from the IMAP account address; more
    // specifically, what happens if the IMAP account name is changed?
    ms_chars->account_a = bh_account_a;

    ;// session->addBuiltInView(msg_store->base_viewpoint);    

    DR_TagArray tag_array;
    if (!(tag_array.add(sizeof(non_bifeid_tags_to_get) /
                        sizeof(non_bifeid_tags_to_get[0]),
                        &non_bifeid_tags_to_get[0])))
    {
        // memory allocation failed
        ticket->res = CdoE_NOT_ENOUGH_MEMORY;
        ticket->completion(ticket);
    }
        

    msg_store->base_viewpoint->getCursor()->setTagArray(tag_array);
    msg_store->base_viewpoint->setQueryFlags(QUERY_ALL_ROWS_FLD_ASSOC);
    // NOTE THE FALSE HERE IN THIS CALL: We are not updating the
    // parent<->child table because we don't know the MDB's object
    // ID, and we're loading the MDB off the back-end store.
    CRSR_GetNextRowTicket * update_row_ticket = new CRSR_GetNextRowTicket;
    update_row_ticket->completed = iemsUpdateRowsCompletion;
    update_row_ticket->p.t = ticket;
    msg_store->base_viewpoint->getCursor()->
        submitGetNextRow(update_row_ticket);
}
#define COMPLETE_NOT_INITED                                             \
    {                                                                   \
        ticket->res = CdoE_NOT_INITIALIZED;                             \
        ticket->completion(ticket);                                     \
        return;                                                         \
    }
#define COMPLETE_NET_ERROR                                              \
    {                                                                   \
        ticket->res = CdoE_NETWORK_ERROR;                               \
        ticket->completion(ticket);                                     \
        return;                                                         \
    }   

static void iemsOpenAllBIFViewsCompletion
(LX_MAPI_OPEN_ALL_BIF_VIEWS * open_bifvs_ticket);


// Helper function that might issue the next ticket in the sequence or
// alternately might get the next row (because we're still looking for MDB or
// root)
static void iemsGetFollowingRowOrIssueNextTick
(LX_MAPI_INIT_EXISTING_MSG_STORE * ticket, bool allow_to_issue)
{
    if (!((ticket->mdb_found) && (ticket->root_found)))
    {
        // We've yet to find at least one of mdb or root, so we go looking for
        // the next row
        CRSR_GetNextRowTicket * update_row_ticket =
            new CRSR_GetNextRowTicket;
        update_row_ticket->completed = iemsUpdateRowsCompletion;
        update_row_ticket->p.t = ticket;
        ticket->msg_store->base_viewpoint->getCursor()->
            submitGetNextRow(update_row_ticket);
    }
    else if (allow_to_issue)
    {
    // The ms_chars is now all done - we can go ahead to opening views and then
    // cleaning up folders

    LX_MAPI_OPEN_ALL_BIF_VIEWS * open_bifvs_ticket =
        new LX_MAPI_OPEN_ALL_BIF_VIEWS;

    open_bifvs_ticket->context = ticket;
    open_bifvs_ticket->msg_store = ticket->msg_store;
    open_bifvs_ticket->completion = iemsOpenAllBIFViewsCompletion;
    submitOpenAllBIFViews(open_bifvs_ticket);        
        ticket->completion(ticket);
    }
}

static void iemsUpdateRowsCompletion(CRSR_GetNextRowTicket * update_row_ticket)
{
    LX_MAPI_INIT_EXISTING_MSG_STORE * ticket =
        (LX_MAPI_INIT_EXISTING_MSG_STORE *)(update_row_ticket->context);

    const MsgStore msg_store = ticket->msg_store;
    const LX_MAPISession * session = msg_store->session;
    const LX_S fh_account_a = ticket->fh_account_a;
    const LX_S bh_account_a = ticket->bh_account_a;
    const bool is_pub = ticket->is_pub;
    const MsCharacteristics ms_chars = msg_store->ms_chars;
    const HRESULT update_rows_res = update_row_ticket->status_o;
    const DR_Row this_row = update_row_ticket->row_o; // may be null on failure

    delete update_row_ticket;
    
    if (update_rows_res != SUCCESS_SUCCESS)
    {
        ticket->res = update_rows_res;
        ticket->completion(ticket);
    }
    
    // Note: According to "main2" code, don't addOIDPairs in this routine

    unsigned int i;
    const unsigned32 offs_mdb = (is_pub) ? BIMOID_OFFS_PUB_MDBOBJ :
        BIMOID_OFFS_USR_UKWN_MDBOBJ;
    const unsigned32 * bifeid_mdb_tag = (unsigned32 *)
        ((is_pub) ? (&(pub_bifeid_mdb_tag[0])) : (&(usr_bifeid_mdb_tag[0])));

    bool this_row_is_root = false;
    bool this_row_is_mdb = false;

    LX_Property obj_name;
    bool obj_name_f;
    LX_Property type_pv;
    bool type_pv_f;

    type_pv_f = this_row.findExact(PR_OBJECT_TYPE, &type_pv);
    const unsigned32 type = (type_pv_f) ? type_pv.getLong() : 0;
        
    obj_name_f = this_row.findAnyType(PR_DISPLAY_NAME_A, &obj_name);
    if (obj_name_f)
    {
        LX_Buffer onb = obj_name.getValue(0);
        if (type == MAPI_FOLDER)
        {
            if (((!is_pub) && (onb.stricompare("mapiroot"))) ||
                ((is_pub) && (onb.stricompare("Public Root"))) ||
                ((!(ticket->root_found)) && (onb.stricompare(""))))
            {
                this_row_is_root = true;
            }
        }
        else if (type == MAPI_STORE)
        {
            this_row_is_mdb = true;
        }
            
    }
    else if ((type == MAPI_FOLDER) && (!(ticket->root_found)))
    {
        this_row_is_root = true;
    }
    else
    {
        // This object is neither MDB or root - probably won't happen
    }
    
    bool submitted_nspi_ticket = false;
    
    if (this_row_is_root)
    {
        ticket->root_found = true;
        
        LX_Property prop;
        bool prop_f;

        // Get the store entry ID
        unsigned8 *scan;

        prop_f = this_row.findExact(PR_STORE_ENTRYID, &prop);
        if ((!prop_f) || (!(prop.getValue(0).size())))
            COMPLETE_NOT_INITED;

        // Take a copy of the store entry ID
        ms_chars->set_store_entry_id(prop);
        // Now read some other useful values that are buried in the
        // store entry ID
        unsigned int scanpos = 4;
        LX_Buffer propbuf = prop.getValue(scanpos); // start 4 bytes into buff
        if (propbuf.copyOut(scanpos,
                            (char *) &(ms_chars->store_entry_id_uid1),
                            16)
            != 16)
            COMPLETE_NOT_INITED;

        scanpos += 16 + 2;             // skip past the UUID and 16-bit zero
        scanpos += (propbuf.strcpyOut(scanpos, 0)+1); // skip past dll name
        scanpos += 7;                  // skip past seven 00 bytes
        if (propbuf.copyOut(scanpos,
                            (char *) &(ms_chars->store_entry_id_uid2), 16)
            != 16)
            COMPLETE_NOT_INITED;
    
        scanpos += 16;                 // skip past store_entry_id_uid2
        scanpos += 4;                  // skip past 4 byte integer
        scanpos += (propbuf.strcpyOut(scanpos, 0)+1); // skip past server name
        
        if (is_pub)
        {
            ms_chars->x400_address = new char[450];
            if ((!Getx400Address(ms_chars->x400_address,
                                 450, fh_account_a)))
            {
                DEBUGX(1, "Failed to get pub folders x400 address");
                COMPLETE_NOT_INITED;
            }
        }
        else
        {
            ms_chars->x400_address = new char [strlen((char *) scan) + 1];
            scanpos += (propbuf.strcpyOut(scanpos, ms_chars->x400_address)+1);
        }

        // Get store record key
        prop_f = this_row.findExact(PR_STORE_RECORD_KEY, &prop);
        if ((!prop_f) ||
            (prop.size() != sizeof(ms_chars->store_record_key)))
            COMPLETE_NOT_INITED;

        if (prop.copyOut(0,
                         &(ms_chars->store_record_key), 
                         sizeof(ms_chars->store_record_key)) !=
            sizeof(ms_chars->store_record_key))
            COMPLETE_NOT_INITED;
    
        // Get prop 3FE1 and take copy
        prop_f = this_row.findExact(PR_3FE1_AF_CODE_PAGE, &prop);
        if ((!prop_f) ||
            (prop.size() != sizeof(ms_chars->val_3FE1)))
            COMPLETE_NOT_INITED;

        if (prop.copyOut(0,
                          &(ms_chars->val_3FE1[0]),
                          sizeof(ms_chars->val_3FE1))
            != sizeof(ms_chars->val_3FE1))
            COMPLETE_NOT_INITED;
                  
        // Get prop 3FFE and take copy
        prop_f = this_row.findExact(PR_3FFE_AF, &prop);
        if ((!prop_f) ||
            (prop.size != sizeof(ms_chars->val_3FFE)))
            COMPLETE_NOT_INITED;

        if (prop.copyOut(0,
                          &(ms_chars->val_3FFE[0]),
                          sizeof(ms_chars->val_3FFE))
            != sizeof(ms_chars->val_3FFE))
            COMPLETE_NOT_INITED;

        if (!is_pub) // subseq2 doesn't exist in public folders
        {
            // Get prop 0E59 and extract subseq2 (subseq2 is the first thing in
            // this property)
            prop_f = this_row.findExact(PR_0E59_AF, &prop);
            if ((!prop_f) ||
                (prop.size() < sizeof(ms_chars->subseq2)))
                COMPLETE_NOT_INITED;

            if (prop.copyOut(0,
                              &(ms_chars->subseq2[0]),
                              sizeof(ms_chars->subseq2))
                != sizeof(ms_chars->subseq2))
                COMPLETE_NOT_INITED;
        }
        

    }
    else if (this_row_is_mdb)
    {
        ticket->mdb_found = true;

        // Find the IPM subtree entry ID and use it to deduce all of the
        // built-in folder object IDs
        prop_f = this_row.findExact(PR_IPM_SUBTREE_ENTRYID, &prop);
        if ((!prop_f) || (prop.size() != LEN_BIFEID))
            COMPLETE_NOT_INITED;

        LX_ObjectId objid;

        if (prop->copyOut(OBJID_OFFS_IN_BIFEID,
                          &objid,
                          sizeof(objid)) != sizeof(objid))
            COMPLETE_NOT_INITED;

        // Then, take a copy of bifeid_uid from within the IPM subfolder's
        // entry id
        if (prop->copyOut((4 + 16 + 2),
                          &(ms_chars->bifeid_uid),
                          sizeof(auid_t)) != sizeof(auid_t))
            COMPLETE_NOT_INITED;

        if (!is_pub)
        {
            // For public folders, the ipm subtree obj ids is the first in the
            // sequence of obj ids of built-in folders
            // 
            // For private folders, root obj id is one less than IPM subtree
            // obj id, and root's objid is the first in the sequence of objids
            // of built-in folders
            --objid;
        }
        // objid is now the first in the sequence of objids of built-in folders

        for (i = 0; i < NUM_BIFEID_BISFEID_AND_BLANKS; i++)
        {
            unsigned8 *b = ms_chars->bifeid_tab[i].b;

            ms_chars->bifeid_tab[i].tag = bifeid_mdb_tag[i];
            ms_chars->bifeid_tab[i].bifeid_offs = i;

            if (prop->copyOut(0, b, OBJID_OFFS_IN_BIFEID) !=
                OBJID_OFFS_IN_BIFEID)
                COMPLETE_NOT_INITED;
        
            b += OBJID_OFFS_IN_BIFEID;
            memcpy(b, objid.cBuf(), sizeof(objid));
            b += sizeof(objid);
            *((unsigned16 *) b) = 0;

            if (i == offs_mdb)
            {
                ms_chars->set_mdb_obj_id(objid);
                ms_chars_implementation->setMDB(ms_chars, objid);
                add_oid_pair(objid, msg_store->base_viewpoint->getObjectId());
            }
            ++objid;
        }

        // We didn't do this when we did the initial updateRows because
        // ms_chars didn't have the object ID of the MDB.  Now,
        // we have it, so we can correctly do this.
        add_oid_pairs_from_table(msg_store->base_viewpoint);        
    }

    if (!is_pub)
    {
        ms_chars->smtp_address = new char[MAX_SMTP_ADDRESS];
        if (!GetSMTPAddress((LPTSTR) (ms_chars->smtp_address),
                            MAX_SMTP_ADDRESS, (LPTSTR) fh_account_a))
            COMPLETE_NOT_INITED;

        LX_MAPI_DUMMY * nspi_ticket = new LX_MAPI_DUMMY;
        nspi_ticket->context = ticket;
        nspi_ticket->completion =
            iemsMsCharsFromNSPICompletion;
        submitDummy(nspi_ticket);
        submitted_nspi_ticket = true;

        /*
         * Comment out the actual setup for the NSPI call... !!!!
         LXTagArray tag_array;
         static LX_PropertyTag nspi_tags[] =
         {
         PR_ENTRYID,
         PR_SEARCH_KEY,
         PR_DISPLAY_NAME_W,
         PR_39FE_SMTP_ADDRESS_W
         };
    
         LX_PropertyTagArray in_inPropTags;
         in_inPropTags.copy(nspi_tags, NUM_ELEMENTS(nspi_tags));
    
         LX_StringA add0(fh_account_a);
         LX_StringVectorA in_addresses_vector;
         in_addresses_vector.append(add0);
         LX_StringArrayA in_addresses(in_addresses_vector);
    
         SampleNSPI_Results res;
    
         HRESULT result = sampleNSPI(in_inPropTags, in_addresses, &res);

        */
    }    

    // Note, in this case we allow issuing of the "open all the rest of the
    // folders"ticket from the helper iemsGetFollowingRowOrIssueNextTick iff
    // there was NO nspi ticket submitted; if an nspi ticket was submitted then
    // issueing of the "open all the rest of the folders" will happen either
    // out of a subsequent completion of the nspi ticket or out of the
    // completion of another get-row ticket
    iemsGetFollowingRowOrIssueNextTick(ticket,
                                       !submitted_nspi_ticket);
}
void MsCharacteristicsI::
iemsMsCharsFromNSPICompletion(LX_MAPI_DUMMY * nspi_ticket)
{
    const HRESULT nspi_res = nspi_ticket->res;
    LX_MAPI_INIT_EXISTING_MSG_STORE * ticket =
        (LX_MAPI_INIT_EXISTING_MSG_STORE *)nspi_ticket->context;

    const MsgStore msg_store = ticket->msg_store;
    const LX_MAPISession * session = msg_store->session;
    const char * fh_account_a = ticket->fh_account_a;
    const char * bh_account_a = ticket->bh_account_a;
    const bool is_pub = ticket->is_pub;
    const MsCharacteristics = msg_store->ms_chars;

    delete nspi_ticket;

    if (!nspi_res)
    {
        // NSPI call succeeded, read its results !!!!
        LX_CHECK(0);
        
        /*

        if ( result == SUCCESS_SUCCESS &&
        res.out_list[0] == NSPI_NameSingleMatch )
        {
        // resolution succeeded, use nspi results
        // to build entry id and search key
    
        DR_Row lx_row(res.out_addrs->arr[0]);
    
        LX_Binary lxb = lx_row->arr[0].getB();
        msg_store->usr_eid.lpb = new unsigned8[lxb->size];
        memcpy(msg_store->usr_eid.lpb, lxb->data, lxb->size);
        msg_store->usr_eid.cb = lxb->size;
    
        lxb = lx_row->arr[1].getB();
        msg_store->usr_search_key.lpb = new unsigned8[lxb->size];
        memcpy(msg_store->usr_search_key.lpb, lxb->data, lxb->size);
        msg_store->usr_search_key.cb = lxb->size;
                
        // don't need these after above line used.
        const WCHAR_T *name = lx_row->arr[2].getW().utxt();
        int len = lx_wcslen(name)+1;
        msg_store->account_full_name = new char[len];
        unicode_to_char(msg_store->account_full_name, name, 0);

        // overwrite DNS-based smtp address with the one
        // from nspi
        const WCHAR_T *smtp_address_w = lx_row->arr[3].getW().utxt();
        delete [] msg_store->smtp_address;
        len = lx_wcslen(smtp_address_w) + 1;
        msg_store->smtp_address = new char[len];
        unicode_to_char(msg_store->smtp_address, smtp_address_w, 0);
        }
        else
        *
        * End of commented out section
        */
    }
    else
    {
        // NSPI call failed, make up results
        if (!GetUsrEID(ms_chars->usr_eid,
                       480,
                       0,
                       (LPTSTR) fh_account_a))
        {
            COMPLETE_NET_ERROR;
        }
    
        ms_chars->usr_search_key.lpb = (unsigned8 *) malloc(480);
        if (!GetUsrSearchKey(ms_chars->usr_search_key,
                             480,
                             0,
                             (LPTSTR) fh_account_a))
        {
            COMPLETE_NET_ERROR;
        }    
    
        if (!GetUsrFullName(ms_chars->account_full_name,
                            450,
                            (LPTSTR) fh_account_a))
        {
            delete ms_chars->account_full_name;
            COMPLETE_NET_ERROR;
        }    
    }

    iemsGetFollowingRowOrIssueNextTick(ticket, allow_to_issue);
}

void iemsOpenAllBIFViewsCompletion
(LX_MAPI_OPEN_ALL_BIF_VIEWS * open_bifvs_ticket)
{
    const HRESULT open_bifvs_res = open_bifvs_ticket->res;
    LX_MAPI_INIT_EXISTING_MSG_STORE * ticket =
        (LX_MAPI_INIT_EXISTING_MSG_STORE *) open_bifvs_ticket->context;
    const MsgStore msg_store = ticket->msg_store;

    delete open_bifvs_ticket;

    if (open_bifvs_res)
    {
        ticket->res = open_bifvs_res;
        ticket->completion(ticket);
        return;
    }

    if( res == SUCCESS_SUCCESS)
    { // Clean up any builtin folder problems
        CleanUpAllBuiltinFolders(session, msg_store, is_pub);
    }
    
    LX_MAPI_DUMMY * clean_up_ticket = new LX_MAPI_DUMMY;
    clean_up_ticket->context = ticket;
    clean_up_ticket->res = SUCCESS_SUCCESS; //remove for non-dummy version !!!!
    clean_up_ticket->completion = iemsCleanUpAllBIFsCompletion;
    submitDummy(clean_up_ticket);
}

void MsCharacteristicsI::
iemsCleanUpAllBIFsCompletion(LX_MAPI_DUMMY * clean_up_ticket)
{
    const HRESULT clean_up_res = clean_up_ticket->res;
    LX_MAPI_INIT_EXISTING_MSG_STORE * ticket =
        (LX_MAPI_INIT_EXISTING_MSG_STORE *)(clean_up_ticket->context);

    delete clean_up_ticket;

    // Finally, return the result to the original ticket
    ticket->res = open_bifvs_res;
    ticket->completion(ticket);
}

/////////////////////////////////////////////////////////////////////////////

#ifdef LEAVE_THIS_FOR_NOW

/////////////////////////////////////////////////////////////////////////////
// Adds the properties that exist in all objects (MDB, folders, and messages)
static void BuildRowForObject(bool is_pub,
                       DR_RW_Row  row,
                       const LX_Property * entry_id,
                       const LX_Property * record_key,
                       const LX_Property * search_key,
                       const char * display_name,
                       unsigned32 object_type, 
                       unsigned32 val_6640, 
                       unsigned32 val_669B_lodw
                       ,LX_SBinary store_entry_id
                       ,LX_SBinary record_key_bin)
{
    LX_SBinary bin;
    
    view.addNew(PR_6640_MDB_AFM, val_6640, row, true);
    view.addNew(PR_6643_MDB_AFM, (unsigned32) 0, row, true);
    view.addNew(entry_id, row, true);
    view.addNew(record_key, row, true);
    view.addNew(search_key, row, true);
    view.addNew(PR_664B_MDB_AFM, 0x600050001B200003ull, row, true);
    view.addNew(PR_STORE_ENTRYID, &store_entry_id, row, true);
    view.addNew(PR_STORE_RECORD_KEY, record_key_bin, row, true);
    
    if ((display_name) && (strlen(display_name)))
    {
        view.addNew(PR_DISPLAY_NAME_A, display_name, row, true);
        view.addNew(PR_COMMENT, display_name, row, true);
    }

    view.addNew(PR_OBJECT_TYPE, object_type, row, true);

    // !!!!
    // One highly interesting point here; it is possible we could
    // prevent Outlook sending us RTF-compressed messages by setting the
    // flag STORE_UNCOMPRESSED_RTF in this mask, but NOT setting
    // STORE_RTF_OK. Leave it like this for now, but worth an experiment
    // once we come to send an email.
    // Exchange2003 val: 0x53FFD
    // STORE_RTF_OK:           0x00000800
    // STORE_UNCOMPRESSED_RTF: 0x00008000
    // 0x53FDD | 0x8000 = 0x5BFDD
    // 0x5BFDD & ~0x0800 = 0x5B7DD
    unsigned32 str_supp_mask = (is_pub) ? 0x57F79ul : 0x53FFDul;
    view.addNew(PR_STORE_SUPPORT_MASK, str_supp_mask, row, true);
    view.addNew(PR_340F_UNKNOWN, str_supp_mask, row, true);

    // allow user modifications
    view.addNew(PR_ACCESS_LEVEL, ((unsigned32) 1), row, true); 

    static const unsigned8 usrstore_mdb_provider[0x10] =
        { 0x54, 0x94, 0xA1, 0xC0, 0x29, 0x7F, 0x10, 0x1B,
        0xA5, 0x87, 0x08, 0x00, 0x2B, 0x2A, 0x25, 0x17
        };
    static const unsigned8 pubstore_mdb_provider[0x10] =
        {
            0x78, 0xB2, 0xFA, 0x70, 0xAF, 0xF7, 0x11, 0xCD,
            0x9B, 0xC8, 0x00, 0xAA, 0x00, 0x2F, 0xC4, 0x5A
        };
    bin.cb = sizeof(usrstore_mdb_provider);
    bin.lpb = (unsigned8 *)((is_pub) ? &(pubstore_mdb_provider[0]) :
                            &(usrstore_mdb_provider[0]));
    view.addNew(PR_MDB_PROVIDER, bin, row, true);

    view.addNew((PR_66A1_MDB_AM_TEMPLATE_LOCALE,
             (unsigned32) srv_characteristics.TemplateLocale), row, true);
    view.addNew(PR_6705_MDBO_SORT_LOCALE,
            (unsigned32) srv_characteristics.SortLocale, row, true);

    view.addNew(PR_669B_MDB_AF, (unsigned long long) val_669B_lodw, row, true);
    view.addNew(PR_669B_MDB_AF,
                (unsigned long long) val_669B_lodw, row, true); // as 669B
    view.addNew(PR_669D_AFM_MDB, 0ull, row, true);
}

/////////////////////////////////////////////////////////////////////////////
// Adds the properties that exist in all objects (MDB, folders, and messages)
static void BuildRowForObject(VP_ObjectViewpoint view,
                       DR_RW_Row  row,
                       const LX_Property * entry_id,
                       const LX_Property * record_key,
                       const LX_Property * search_key,
                       const char * display_name,
                       unsigned32 object_type, 
                       unsigned32 val_6640, 
                       unsigned32 val_669B_lod)
{

    const MsgStore msg_store = view->getFE_MsgStore();
    const MsCharacteristics ms_chars = msg_store->ms_chars;
    
    bool is_pub = ms_chars->is_pub;

    LX_SBinary tmp_bin;
    ms_chars->get_store_entry_id_ptr(tmp_bin);

    LX_SBinary record_key_bin;
    record_key_bin.lpb = (unsigned8 *) (&(ms_chars->store_record_key));
    record_key_bin.cb = sizeof(ms_chars->store_record_key);

    BuildRowForObject(is_pub,
                      row,
                      entry_id,
                      record_key,
                      search_key,
                      display_name,
                      object_type, 
                      val_6640, 
                      val_669B_lod,
                      tmp_bin,
                      record_key_bin);
}


/////////////////////////////////////////////////////////////////////////////
/*
 * GetAncestorBifeidOffset takes a view and returns the built-in
 * folder offset of the most recent ancestor of the object refered to
 * by the view that is a built in folder. If the view passed in is
 * itself a built in folder, the return value is that folder's own
 * built-in folder offset. If no folder is found, NO_INDEX is
 * returned. Be careful to check is_pub before using the return value
 * of this function.
 */

unsigned int GetAncestorBifeidOffset(VP_ObjectViewpoint view)
{
  unsigned int index;
  
  MsgStore msg_store = view->getFE_MsgStore();
  if (!msg_store)
    return(NO_INDEX);

  while((index =
         get_bifeid_index_from_obj_id(view->getObjectId(), msg_store)) ==
        NO_INDEX)
    {
      view = view->getParent();
      if (!view)
        break;
    }
  return(index);
}

//dwf start
//
// functions to handle Ancestry lists stored in LX_SBinary
//
// --------------------------------------------------------------------------
// ancestry_getCount - return the number of ancestors
// ancestry_getObjID - return Nth parant's LX_ObjectId 
// ancestry_getXtObjID - return Nth parant's LX_ExtendedObjectId
// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
/// ref_oid2xchg_oid - get LX_ObjectId from a PR_..._REF_OID LX_Property 
// --------------------------------------------------------------------------
void ref_oid2xchg_oid( const LX_Property *ref_oid_prop, LX_ObjectId& ObjID)
{
    
    if (ref_oid_prop->getPropType() == PT_I8)
    {
        unsigned64 oid_as_ll = ref_oid_prop->getUnsignedLongLong();
        
        unsigned8 *cptr = (unsigned8 *)&ref_oid_prop->val;
        ObjID.setFromBuf(((unsigned8 *)&oid_as_ll)+2);
        return;
    }
    else
    {
        LX_CHECK(0); // should never happen
        memset(&ObjID, 0xFF, sizeof(ObjID));
    }
                
} // end of ref_oid2xchg_oid

// --------------------------------------------------------------------------
// ancestry_getCount - return the number of ancestors
// --------------------------------------------------------------------------
int ancestry_getCount( LX_SBinary *psb)
{
    int count = psb->cb / 8;    // 8 = sizeof( LX_ExtendedObjectId)
    
    LX_CHECK((psb->cb % 8) == 0);    // should be a multiple of 8
    
    return count;
} // end of ancestry_getCount

// --------------------------------------------------------------------------
// ancestry_getObjID - return Nth parant's LX_ObjectId 
// --------------------------------------------------------------------------
LX_ObjectId ancestry_getObjID( unsigned32 nth, LX_SBinary *psb)
{
    LX_ObjectId oid;
    nth *= 8;    // convert parent number to byte offset
    if( nth > psb->cb - 8) nth = psb->cb - 8;  // return O (last)

    for( int jk=0; jk < 6; jk++)
    {
        oid.b[ jk] = psb->lpb[ nth+jk+2];
    }
    
    
    return oid;
} // end of ancestry_getObjID


// --------------------------------------------------------------------------
// ancestry_getXtObjID - return Nth parant's LX_ExtendedObjectId
// --------------------------------------------------------------------------
LX_ExtendedObjectId ancestry_getXtObjID( unsigned32  nth, LX_SBinary *psb)
{
    LX_ExtendedObjectId xoid;
    nth *= 8;    // convert parent number to byte offset
    if( nth > psb->cb - 8) nth = psb->cb - 8;  // return O (last)

    xoid.prefix = (psb->lpb[nth+0] << 8) | psb->lpb[nth+1];
    xoid.id = ancestry_getObjID( nth/8, psb);
    
    return xoid;
} // end of ancestry_getXtObjID


// --------------------------------------------------------------------------
//dwf end

/////////////////////////////////////////////////////////////////////////////
// The helper function GetFolderDependentUUID returns a pointer to the
// first of 16 bytes of a UUID. For Inbox and deferred action, the
// poiunter is to the mapping signature, otherwise it is to the
// bifeid_uid
unsigned8 *GetFolderDependentUUID(VP_ObjectViewpoint view, // of folder
                                  const MsgStore msg_store)
{
    const MsCharacteristics ms_chars = msg_store->ms_chars;
    
    if (msg_store->is_pub)
    {
        return((unsigned8 *) (&(ms_chars->bifeid_uid)));
    }
    else
    {
        unsigned int bifeid_offs = GetAncestorBifeidOffset(view);
      
        return (((bifeid_offs == BIFEID_OFFS_USR_661F_DEFERRED_ACTION) ||
                 (bifeid_offs == BIFEID_OFFS_USR_UKWN_INBOX) ||
                 (bifeid_offs == BISFEID_OFFS_USR_UKWN_FREEBUSY_DATA)) ?
                (srv_characteristics.mapping_signature.lpb) :
                ((unsigned8 *) (&(ms_chars->bifeid_uid))));
    }
}

/////////////////////////////////////////////////////////////////////////////
/*
 * This helper function fills in the SBinary required for property 6619 and
 * 3FF9. Note that it must not be called for objects in the public folders.
 *
 * NOTE: Calling this routine assumes you want to initialize and fill in
 * completely the bin_ptr. Therefore, if you want to append to what is there
 * you'd better do something else (i.e. check where this is called multiple
 * times from methods.
 *
 * NOTE: x3ff9 is  a.k.a. PR_CREATOR_ENTRYID
 */
void BuildBinFor6619or3FF9(const MsgStore msg_store, LX_SBinary * bin_ptr)
{
    MsCharacteristics ms_chars = msg_store->ms_chars;
    
    bin_ptr->cb=0;      // cmc: initialize before fill up.

    // Setup 6619

    //     0X6619    PT_BINARY    cb: 103    *pb: -- occurs in MDB only
    // 00 00 00 00
    append_unsigned32_to_SBinary(bin_ptr, 0);

    // A UUID followed by 32-bit one. This UUID recurs in various places,
    // always with the one.
    // Call this UUID1:
    // DC A7 40 C8 C0 42 10 1A
    //         B4 B9 08 00 2B 2F E1 82
    append_uuid_to_SBinary(bin_ptr, &(ms_chars->store_entry_id_uid1));


    // 01 00 00 00
    append_unsigned32_to_SBinary(bin_ptr, 0x1);

    // 00 00 00 ;00
    append_unsigned32_to_SBinary(bin_ptr, 0);

    // -- The next part of this ID is a null terminated string, namely the
    // x400 address of this user, capitalized.
    // 2F 4F 3D 53 49 44 45
    // 57 41 59 53 20 53 4F 46 54 57 41 52 45 2F 4F 55 3D 46 49 52 53 54 20
    // 41 44 4D 49 4E 49 53 54 52 41 54 49 56 45 20 47 52 4F 55 50 2F 43 4E
    // 3D 52 45 43 49 50 49 45 4E 54 53 2F 43 4E 3D 44 47 54 45 53 54 00 
    // /O=SIDEWAYS SOFTWARE/OU=FIRST ADMINISTRATIVE GROUP
    // /CN=RECIPIENTS/CN=DGTEST.
    strcpy((char *) (bin_ptr->lpb + bin_ptr->cb), ms_chars->x400_address);
    lx_strupr((char *) (bin_ptr->lpb + bin_ptr->cb));
    bin_ptr->cb += (strlen(ms_chars->x400_address) + 1);
}
void BuildBinFor6619or3FF9(VP_ObjectViewpoint view, LX_SBinary * bin_ptr)
{
    MsgStore msg_store = view->getFE_MsgStore();
    BuildBinFor6619or3FF9(msg_store, bin_ptr);
}

/////////////////////////////////////////////////////////////////////////////
// Adds "All Messages" and "All Messages + MDB" properties
static void BuildRowForMessageOrMDB(DR_RW_Row row, unsigned32 msg_size)
{
    view.addNew(PR_MESSAGE_SIZE, msg_size, row, true);
}

//////////////////////////////////////////////////////////////////////////////
/* total_subfolders_count returns the number of subfolders, plus
 * subfolders of subfolders, plus subfolders of subfolders of
 * subfolders etc. ad infinitum, of the folder with attribute
 * structure "bif" within the folder attribute array
 */
unsigned32 total_subfolders_count(const BIF_ATTRIBS * bif)
{
    unsigned32 i;
    unsigned32 bifs_index;

    bifs_index = 0;
    for (i = 0; i < bif->num_subfolders; i++)
    {
        bifs_index++;
        bifs_index += total_subfolders_count(&(bif[bifs_index]));
    }
    return (bifs_index);
}


/////////////////////////////////////////////////////////////////////////////
// Adds the properties that exist only in the MDB
static void BuildMDBOProps(VP_ObjectViewpoint view,
                           unsigned32 ulFlags,
                           DR_RW_Row  this_row,
                           bool is_pub)
{
    unsigned int i;

    LX_SBinary bin;

    MsgStore msg_store = view->getFE_MsgStore();
    MsCharacteristics ms_chars = msg_store;

    bin.cb = 0;
    bin.lpb = (unsigned8 *) malloc(950);

    const unsigned8 * astr_txt = (unsigned8 *) malloc(950);

    if (!is_pub)
    {
        BuildBinFor6619or3FF9(view, &bin);
        this_view.addNew(PR_6619_MDBO, &bin, row, true);
        
        this_view.addNew(PR_661A_MDBO_ACCOUNT_A, ms_chars->account_a, row, true);
        this_view.addNew(PR_661B_MDBO, &bin, row, true);  // Same as 6619
        this_view.addNew(PR_661C_MDBO_ACCOUNT_A, ms_chars->account_a, row, true);
    }

    this_view.addNew(PR_661D_MDBO, (bool) 0, row, true);   

    if (is_pub)
    {
        // Add the 7C06, 7C07, 7C0C, 7C0D, and 7C11 props - specific to public
        // folders

        // Adds "\Global Address List" as the first and only entry in the MV
        // array
        this_view.addNew(PR_7C06_MDBO_ADDR_LIST_PATH, "\\Global Address List", row, true);
        

        // None of these sequences (of val_7C07) appear in any other property
        static const unsigned8 val_7C07[] = 
            {
                0x01, 0x00, 0x00, 0x00, 0xDC, 0xC5, 0x63, 0xEF,
                0xBE, 0xA9, 0xD6, 0x49, 0x88, 0xCE, 0xFF, 0x48,
                0xD9, 0x0A, 0x3A, 0xE0, 0x01, 0x08, 0x00, 0x00,
                0x00, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                0xED, 0x9A, 0x25, 0x82, 0x36, 0x19, 0x6E, 0x45,
                0x8A, 0xBF, 0x21, 0x44, 0x57, 0x5F, 0x05, 0x9B,
                0x00, 0x00, 0x00, 0xA5, 0x08, 0x01, 0x00, 0x00,
                0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
            };
        LX_SBinary bin_7C07;
        bin_7C07.cb = sizeof(val_7C07);
        bin_7C07.lpb = (unsigned8 *) &(val_7C07[0]); // cast away "const"
        this_view.addNew(PR_7C07_MDBO_UNKNOWN, &bin_7C07, row, true);       
        
        this_view.addNew(PR_7C0C_MDBO_UNKNOWN, (unsigned32) 0, row, true);
        this_view.addNew(PR_7C0D_MDBO_UNKNOWN, 0ull, row, true);
        this_view.addNew(PR_7C11_MDBO_UNKNOWN, true, row, true);       
    }
    

    // Valid folder mask exists only in MDB
    this_view.addNew(PR_VALID_FOLDER_MASK, (unsigned32) 0xFF, row, true);

    for (i = 0; i < NUM_BIFEID; i++)
    {
        LX_SBinary prop_bifeid_bin;
        prop_bifeid_bin.cb = LEN_BIFEID;

        if (ms_chars->bifeid_tab[i].tag)
        {
            // This built-in folder has its entry ID saved in the MDB
            prop_bifeid_bin.lpb = ms_chars->bifeid_tab[i].b;
            this_view.addNew(ms_chars->bifeid_tab[i].tag, &prop_bifeid_bin, row, true);
        }
    }

    this_view.addNew(PR_66C3_MDBO_CODE_PAGE,
                  (unsigned32) (srv_characteristics.CodePage), row, true);
    // STORE_HAS_SEARCHES flag
    this_view.addNew(PR_STORE_STAT, (is_pub) ? 0ul : 0x1000000ul, row, true);
    this_view.addNew(PR_6632_MDBO, is_pub, row, true);
    this_view.addNew(PR_65E4_MDBO, (unsigned32) 0, row, true);

    // PR_CONTENT_COUNT and PR_ASSOC_CONTENT_COUNT do occur in folders
    // too of course but here we have "special" values
    this_view.addNew(PR_CONTENT_COUNT, 0ull, row, true);
    this_view.addNew(PR_ASSOC_CONTENT_COUNT, (unsigned32) 4), row, true); // 0x367

    free(bin.lpb);
    free(astr_txt);
}

/////////////////////////////////////////////////////////////////////////////
// This function can fail!
static void BuildRowForNewMDB(VP_FolderTableViewpoint view,
                              DR_RW_Row this_row,
                              unsigned32 ulFlags,
                              bool is_pub)
{

    MsgStore msg_store = view->getFE_MsgStore();
    MsCharacteristics ms_chars = msg_store->ms_chars;
    LX_SBinary tmp_entry;
    LX_SBinary record_key_bin;
    char        display_name[220];

    ms_chars->get_store_entry_id_ptr(tmp_entry);
    record_key_bin.lpb = (unsigned8 *) (&(ms_chars->store_record_key));
    record_key_bin.cb = sizeof(ms_chars->store_record_key);
    
    LX_Property prop_entry_id(PR_ENTRYID, &tmp_entry);
    LX_Property prop_search_key(PR_SEARCH_KEY, &tmp_entry); // same as eid
    LX_Property prop_record_key(PR_RECORD_KEY, record_key_bin);
    
    if (ms_chars->is_pub)
      {
        strcpy(display_name, "Public Folders");
      }
    else
      {
        strcpy(display_name, "Mailbox - ");
        strcat(display_name, ms_chars->account_a);
      }

    BuildRowForObject(view,
                      *this_row, 
                      &prop_entry_id, 
                      &prop_record_key, 
                      &prop_search_key,    // search key == entryid for MDB
                      display_name, 
                      1,      // 1 == MAPI_STORE (object type),
                      2,      // val_6640; 2 for MDB and deleted items
                      1306    // val_669B_lodw: 1306 for MDB Del Items, else 0
                     );

    BuildRowForMessageOrMDB(this_row, 1024);
    BuildMDBOProps(view, ulFlags, this_row, is_pub);
}

